"""
Unit Testing Lab
Helper Script

Runs the tests contained in tests.py for multiple candidate .py source files.
The results are printed to the screen, and the total number of "wrong" .py files
that fail a test is reported at the end.

Professor Lam
September 2014
"""

import os

# candidate files to test
ALL_FILES = [ "correct.py",
              "wrong01.py",
              "wrong02.py",
              "wrong03.py",
              "wrong04.py"
            ]

def main():
    failed = 0

    # for each candidate
    for fn in ALL_FILES:
        print("\n=====  TESTING " + fn + "  =====")

        # copy candidate into a temporary file (candidate.py)
        with open(fn, "r") as f_in:
            with open("candidate.py", "w") as f_out:
                for line in f_in.readlines():
                    f_out.write(line)

        # run tests
        if os.system("python3 tests.py") != 0:
            failed += 1

    # how many .py files actually failed a test?
    print("\nTOTAL FAILED " + str(failed) + "/" + str(len(ALL_FILES)))


if __name__ == "__main__":
    main()

